#pragma once

#include <cstdlib>
#include <ctime>

#include "TThread.h"
#include "TSystem.h"

#include  "setup.h"
#include "../Headers/readerwriterqueue/atomicops.h"
#include "../Headers/readerwriterqueue/readerwriterqueue.h"

Cone createCone(const Setup* const config);

typedef moodycamel::BlockingReaderWriterQueue<Cone> SPSC;

class Worker
{
private:
    // SPSC queue
    SPSC* coneQueue;
    // config
    const Setup* config;
    // thread
    TThread *h1;
    // counts
    ULong64_t counts=0;
    // capacity
    ULong64_t capacity=1024;
public:
    Worker(const Setup* config_, SPSC* spsc): config(config_), coneQueue(spsc) {
        h1 = new TThread("h1", (void(*)(void *))&Worker::handle, (void*) this);
        h1->Run();
    };
    ~Worker() {
        delete h1;
    }
    void *handle(void *ptr);
};
